Subject: Use (int) instead of intval() or (integer)
Description

When testing for the identity of integers using the intval() function has worse performance than a type cast with (int). (3-5x)

Replace all ~1600 calls to intval() with a type cast.

Related issues:
related to Coding Guidelines - Task # 53113: Use short version of type names Resolved 2013-10-24
related to Core - Task # 54085: Replace all strcmp() calls with === Resolved 2013-11-29
related to Core - Bug # 61699: Workspace Preview not working with lockSSL=3 Resolved 2014-09-18
related to Core - Bug # 55753: pagetype is not respected in pagecache Resolved 2014-02-07
precedes Core - Bug # 55706: Different behavior of levelmedia in TYPO3 6.2 Resolved 2014-02-05

Associated revisions
Revision 9646d26b - 2014-02-01 22:13 - Jo Hasenau

[TASK] Use (int) instead of intval() or (integer)

This patch replaces most of around 1600 occurrences of
intval() and every (integer) in the whole core.
Additionally it changes GeneralUtility::intExplode to use references
and typecasting as well.
Some occurrences of strstr() together with intval() have been replaced
with strpos() as well.
And some superfluous intval calls have been removed or reduced
to a single one i.e. for protected variables or before loops.
Patch updated after Core CGL decision from 30.01.2014

Resolves: #54265
Releases: 6.2
Change-Id: Iba57ffad1f4233ffa1a9f7d3ca5bfe9d2b53f1e8
Reviewed-on: https://review.typo3.org/26740
Reviewed-by: Stefan Neufeind
Tested-by: Stefan Neufeind
Revision ede69ff6 - 2014-09-18 11:36 - Oliver Hader

[BUGFIX] Workspace Preview not working with lockSSL=3

The workspace preview does not work with lockSSL=3 being defined
in the Install Tool. First it looks like a CSS issue, in the end
it boils down that the preview IFRAMEs are not correctly
initialized in Workspaces\Hook\TypoScriptFrontendControllerHook.

The mentioned hook is only called once for the request to the
first IFRAME showing the website frontend preview and won't be
called for further.

The reason is, that cache expire headers are sent that prevent
the client to update the preview on each preview request.
That's why the mentioned hook is not called and the IFRAMEs
are not initialized properly. No-Cache headers are sent if a
backend user object is initialized correctly - and that's the
actual bug, a wrong but strict PHP condition, comparing a string
(lockSSL) with an integer value.

The comparison flaw was integrated with issue #54265

Change-Id: I13c5c2f22f5b43b49f8eead88f1bc82daf415cbb
Resolves: #61699
Releases: master, 6.2
Reviewed-on: http://review.typo3.org/32851
Reviewed-by: Wouter Wolters <typo3@wouterwolters.nl>
Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Markus Klein <klein.t3@reelworx.at>
Reviewed-by: Oliver Hader <oliver.hader@typo3.org>
Tested-by: Oliver Hader <oliver.hader@typo3.org>

Revision 9c0ba3a9 - 2014-09-18 11:36 - Oliver Hader

[BUGFIX] Workspace Preview not working with lockSSL=3

The workspace preview does not work with lockSSL=3 being defined
in the Install Tool. First it looks like a CSS issue, in the end
it boils down that the preview IFRAMEs are not correctly
initialized in Workspaces\Hook\TypoScriptFrontendControllerHook.

The mentioned hook is only called once for the request to the
first IFRAME showing the website frontend preview and won't be
called for further.

The reason is, that cache expire headers are sent that prevent
the client to update the preview on each preview request.
That's why the mentioned hook is not called and the IFRAMEs
are not initialized properly. No-Cache headers are sent if a
backend user object is initialized correctly - and that's the
actual bug, a wrong but strict PHP condition, comparing a string
(lockSSL) with an integer value.

The comparison flaw was integrated with issue #54265

Change-Id: I13c5c2f22f5b43b49f8eead88f1bc82daf415cbb
Resolves: #61699
Releases: master, 6.2
Reviewed-on: http://review.typo3.org/32857
Reviewed-by: Oliver Hader <oliver.hader@typo3.org>
Tested-by: Oliver Hader <oliver.hader@typo3.org>

History
#1 - 2013-12-07 15:38 - Jo Hasenau

Actually the impact is around factor 2.5 not 3 to 5 but still it should be worth switching from intval() to (int).

There is one execpetion though, which is the "base" parameter of the intval() function.
Don't know yet, if this is actually used within the TYPO3 core, but if it is, then intval() should not be replaced.

#2 - 2013-12-07 17:19 - Markus Klein

Hi! Thanks for fiddling around with this.

Before we invest that much time here (the replacement with a regexp is fast, but the review is very cumbersome), we'd discuss this on the core list
first.
I've a gut feeling that not too many devs will support this and therefor it might be hard to get it merged finally.

Cheers Markus

#3 - 2013-12-07 17:20 - Markus Klein
- Parent task set to #52949

#4 - 2013-12-07 17:29 - Steffen Ritter

We discuessed this shortly on the release team meeting as we are concepting the performance improvements.

We are in - but need to make sure that it's really the same :)

#5 - 2013-12-07 17:36 - Mathias Schreiber

Hi joey,

in general: great idea.
I suggest changing the topic to "replace intval() with (int) where it makes sense" in order to make it sound less ranty

#6 - 2013-12-07 17:46 - Steffen Ritter
- Subject changed from Replace all intval() with (int) to Replace all intval() with (int) wherever it makes sense
#7 - 2013-12-07 19:44 - Jo Hasenau

So I will go for it but do it the "semiautomatic" way.

It might take a bit more patchsets than #54085 but IMHO it was working quite well to have a limited number of changes per patchset. So reviewing will
be easier and discussing can happen on the way through the patchsets. After all there might be less context related things to discuss than with
strcmp().

BTW: According to some PHP benchmarking pages I have some more candidates like array_unique or array_key_exists on my list. So if you guys
already found some others, feel free to assign the tasks to me.

#8 - 2013-12-11 07:26 - Stefan Froemken

Please correct me, but I may read that we want to use (integer) instead of (int). Same with (boolean) instead of (bool). I think we should use the same
style everywhere.

#9 - 2013-12-11 09:05 - Jo Hasenau

Agreed to use the same style, but in that case it should be (int) and (bool) for everything, since these are less "bloaty" while still easily understandable.

#10 - 2013-12-11 16:20 - Stefan Neufeind

Please see current thread on the core-mailinglist about CGL-decisions like these ("integer or int"). There is a notes-document to sum up decisions,
their pros/cons etc.

#11 - 2014-01-08 22:11 - Jo Hasenau

So could someone take care of that document and confirm one or the other way.
https://notes.typo3.org/p/CGL-decisions

It's not necessary to decide everything but at least the (bool) (int) vs. (boolean) (integer) thingie should be decided before I go on with this task.

#12 - 2014-01-10 14:55 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#13 - 2014-01-10 15:32 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#14 - 2014-01-10 15:51 - Gerrit Code Review
Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#15 - 2014-01-10 16:15 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#16 - 2014-01-10 16:19 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#17 - 2014-01-10 16:26 - Chris topher
- Subject changed from Replace all intval() with (int) wherever it makes sense to Use (integer) instead of intval() or (int)

#18 - 2014-01-10 17:07 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#19 - 2014-01-10 17:33 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#20 - 2014-01-10 19:06 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#21 - 2014-01-10 20:11 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#22 - 2014-01-10 20:59 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#23 - 2014-01-10 22:55 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740
#24 - 2014-01-11 17:10 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#25 - 2014-01-11 17:33 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#26 - 2014-01-14 23:16 - Gerrit Code Review

Patch set 14 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#27 - 2014-01-14 23:39 - Gerrit Code Review

Patch set 15 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#28 - 2014-01-28 09:54 - Ernesto Baschny
- Parent task changed from #52949 to #55078

#29 - 2014-01-30 17:32 - Ingo Schmitt

Core decision as from today: it should be written (int)$variable

#30 - 2014-01-30 18:18 - Gerrit Code Review

Patch set 16 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#31 - 2014-01-30 18:35 - Gerrit Code Review

Patch set 17 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#32 - 2014-01-30 23:35 - Gerrit Code Review

Patch set 18 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#33 - 2014-01-31 09:53 - Bernhard Kraft
What are the (php internal?) differences between intval() and a (int) typecast?

Is it only that intval() takes a base argument (defaulting to 10) and the difference in speed or are there other specialities?

Could someone point me to a document on that case?

#34 - 2014-01-31 10:27 - Jo Hasenau

It's exactly that: A difference in speed and memory consumption.

The rule of thumb is:

    1. The right operator or typecast is better than 
    2. the right native function is better than 
    3. your own optimized method for the same purpose

So as long as there is no need for a different base, you should do a typecast to (int) instead of intval().

This might be irrelevant with future PHP versions, since the PHP guys might improve performance as well, but still we can be sure that the function
call will never outperform the typecast.

http://www.php.net/manual/de/language.types.type-juggling.php
http://www.php.net/manual/de/language.types.integer.php#language.types.integer.casting

<quote>
To explicitly convert a value to integer, use either the (int) or (integer) casts. However, in most cases the cast is not needed, since a value will be
automatically converted if an operator, function or control structure requires an integer argument. A value can also be converted to integer with the
intval() function.
</quote>

#35 - 2014-01-31 18:11 - Gerrit Code Review

Patch set 19 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#36 - 2014-01-31 18:27 - Gerrit Code Review

Patch set 20 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#37 - 2014-02-01 21:49 - Gerrit Code Review

Patch set 21 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#38 - 2014-02-01 21:53 - Gerrit Code Review

Patch set 22 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26740

#39 - 2014-02-01 22:30 - Jo Hasenau
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:9646d26bac991dd23b5d58e7b85ab72d7a4af870.

#40 - 2014-02-14 02:20 - Simon Schaufelberger

can somebody please share the script how to do that automatically or was everything done manually? I want to use that for my own extensions as
well!

#41 - 2014-02-14 09:18 - Jo Hasenau

This was done manually, since I wanted to take care of surrounding issues as well, which would have been impossible with an automated search and
replace.
The goal was to get rid of superfluous method calls and typecasts additionally. So the only helper was PHPstorm to find the occurrences and provide a
local history of the changes.

#42 - 2014-03-20 12:58 - Chris topher
- Subject changed from Use (integer) instead of intval() or (int) to Use (int) instead of intval() or (integer)
